﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GetInputText
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            GetTextFromForegroundWindow();
        }

        const int WM_GETTEXT = 0x000D;
        const int WM_GETTEXTLENGTH = 0x000E;

        [DllImport("user32.dll", EntryPoint = "SendMessageA")]
        public static extern int SendMessage(IntPtr hwnd, int wMsg, int wParam, Byte[] lParam);

        [DllImport("user32.dll", EntryPoint="SendMessageA")]
        public static extern int SendMessage(IntPtr hwnd, int wMsg, int wParam, int lParam);

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        /// <summary>
        /// 全局监听激活的应用输入框的内容
        /// </summary>
        /// <param name="hWnd"></param>
        public void GetTextFromForegroundWindow()
        {
            IntPtr hWnd = GetForegroundWindow();
            int len = SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
            if (len > 0)
            {
                Byte[] buffer = new Byte[len + 1];
                SendMessage(hWnd, WM_GETTEXT, len + 1, buffer);
                string text = Encoding.Default.GetString(buffer);
                text = text.Substring(0, text.Length - 1);
                if (text != "")
                {
                    this.tbContent.Text = text;
                }
            }
        }
    }
}
